<?php
require_once (PATH_CONTROLLERS . "Common.php") ;
require_once (PATH_MODELS . "activity/ModelClass.php") ;
require_once (PATH_MODELS . "activity/BrandClass.php") ;

class Model extends ControllerBase {
	private $type = "" ;
	function __construct() {
		$this->db = $_SESSION[SE_DB] ;
	}
	function __destruct() {
		unset($this->db) ;
	}
	public function processRequest($params) {
		$this->type = REQ_VIEW ;
		
		try {
			$this->db->open() ;
			if (isset($params) && count($params) > 0) {
				if (isset($params['type']))
					$this->type = $params['type'] ;
			}
			switch ($this->type) {
				case REQ_ADD:
					$this->addRecord($params) ;
					break ;
				case REQ_UPDATE:
					$this->updateRecord($params) ;
					break ;
				case REQ_DELETE:
					$this->deleteRecord($params) ;
					break ;
				case REQ_GET:
					$this->getRecord($params) ;
					break ;
				case REQ_LIST:
					$this->getList($params) ;
					break ;
				case REQ_REPORT:
					$this->getReport($params) ;
					break ;
				case REQ_VIEW:
					$this->getView() ;
					break ;
				default:
					$this->sendJsonResponse(Status::Error,"invalid request.","",$this->type) ;
					break ;
			}
			$this->db->close() ;
			return true ;
		} catch (Exception $e) {
			$this->db->close() ;
			die ($e->getMessage()) ;
		}
	}
	private function addRecord($params) {
		$cls 		= new ModelClass($this->db) ;
		$datas 		= array() ;
		$orgid 		= $_SESSION[SE_ORGID] ;
		$modifyby 	= $_SESSION[SE_USERID] ;
		$modifydate = date_create('now')->format('Y-m-d H:i:s') ;
		$ws 		= $_SESSION[SE_REMOTE_IP];
		
		$datas[] = $this->db->fieldValue(ModelTable::C_DESC,$this->getParam($params,'desc',"")) ;
		$datas[] = $this->db->fieldValue(ModelTable::C_CODE,$this->getParam($params,'code',"")) ;
		$datas[] = $this->db->fieldValue(ModelTable::C_REF,$this->getParam($params,'ref',"")) ;
		$datas[] = $this->db->fieldValue(ModelTable::C_BRAND_ID,$this->getParam($params,'brand',"")) ;
		$datas[] = $this->db->fieldValue(ModelTable::C_ORG_ID,$orgid) ;
		$datas[] = $this->db->fieldValue(ModelTable::C_WS_ID,$ws) ;
		$datas[] = $this->db->fieldValue(ModelTable::C_MODIFY_BY,$modifyby) ;
		$datas[] = $this->db->fieldValue(ModelTable::C_CREATE_BY,$modifyby) ;
		$datas[] = $this->db->fieldValue(ModelTable::C_MODIFY_DATE,$modifydate) ;
		$datas[] = $this->db->fieldValue(ModelTable::C_CREATE_DATE,$modifydate) ;
		
		try {
			$id = $cls->addRecord($datas) ;
			if ($id > 0) {
				$this->sendJsonResponse(Status::Ok,"Model successfully added to the system.",$id,$this->type);
			} else {
				$this->sendJsonResponse(Status::Error,"Sorry, there is a error in adding new Model to the system.",$id, $this->type) ;
			}
		} catch (Exception $e) {
			Log::write('[Model]' . $e->getMessage());
			$this->sendJsonResponse(Status::Error,"Sorry, there is a error in database operation.","",$this->type) ;
		}
		unset($cls) ;
	}
	private function updateRecord($params) {
		if (isset($params['id'])) {
			$id = $params['id'] ;
			$cls = new ModelClass($this->db) ;
			try {
				$datas = array() ;
                
                $modifyby 	= $_SESSION[SE_USERID] ;
                $modifydate = date_create('now')->format('Y-m-d H:i:s') ;
                $ws = $_SESSION[SE_REMOTE_IP] ;

				$datas[] = $this->db->fieldValue(ModelTable::C_DESC,$this->getParam($params,'desc',"")) ;
				$datas[] = $this->db->fieldValue(ModelTable::C_CODE,$this->getParam($params,'code',"")) ;
				$datas[] = $this->db->fieldValue(ModelTable::C_REF,$this->getParam($params,'ref',"")) ;
				$datas[] = $this->db->fieldValue(ModelTable::C_BRAND_ID,$this->getParam($params,'brand',"")) ;
                $datas[] = $this->db->fieldValue(ModelTable::C_WS_ID,$ws) ;
                $datas[] = $this->db->fieldValue(ModelTable::C_MODIFY_BY,$modifyby) ;
                $datas[] = $this->db->fieldValue(ModelTable::C_MODIFY_DATE,$modifydate) ;
                
				$cls->updateRecord($id,$datas) ;
				$this->sendJsonResponse(Status::Ok,"Model successfully updated to the system.",$id,$this->type) ;
			} catch (Exception $e) {
				Log::write('[Model]' . $e->getMessage());
				$this->sendJsonResponse(Status::Error,"Sorry, there is a error in updating Model to the system.","",$this->type) ;
			}
			unset($cls) ;
		}else {
			$this->sendJsonResponse(Status::Error,"You must supply the Model id you wish to update. Please try again.","",$this->type);
		}
	}
	private function deleteRecord($params) {
		if (isset($params['id'])) {
			$id = $params['id'] ;
			$cls = new ModelClass($this->db) ;
			try {
				$cls->deleteRecord($id) ; 
				$this->sendJsonResponse(Status::Ok,"Model successfully deleted from the system.","",$this->type);
			} catch (Exception $e) {
				Log::write('[Model]' . $e->getMessage());
				$this->sendJsonResponse(Status::Error,"Sorry, there is a problem in deleting Model record from the system.","",$this->type) ;
			}
			unset($cls) ;
		} else {
			$this->sendJsonResponse(Status::Error,"You must supply the Model id you wish to delete. Please try again.","",$this->type);
		}
	}
	private function getList($datas=null) {
		// $cls = new ModelClass($this->db) ;
		// $clsBrand = new BrandClass($this->db) ;
		// $filter = $this->db->fieldParam(ModelTable::C_ORG_ID) ;
		// $params = array() ;
		// $params[] = $this->db->valueParam(ModelTable::C_ORG_ID,$_SESSION[SE_ORGID]) ;
		// $rows = $cls->getTable($filter,ModelTable::C_DESC,$params) ;
		// $list = "" ;
		// foreach ($rows as $row) {
		// 	$id = $row[ModelTable::C_ID] ;
		// 	$brand = ($row[ModelTable::C_BRAND_ID]==0)?'-':$clsBrand->getRecord($row[ModelTable::C_BRAND_ID])[BrandTable::C_DESC];

		// 	$list .= "<tr>" ;
		// 	$list .= "<td>" . $id . "</td>" ;
		// 	$list .= "<td>" . $row[ModelTable::C_CODE] . "</td>" ;
		// 	$list .= "<td>" . $row[ModelTable::C_DESC] . "</td>" ;
		// 	$list .= "<td>" . $brand . "</td>" ;
		// 	$list .= "<td style='text-align:center'><a href='javascript:' onclick='editModel(" . $id . ",this)'><img src='image/edit_16.png' title='Edit'></img></a></td>" ;
		// 	$list .= "<td style='text-align:center'><a href='javascript:' onclick='deleteModel(" . $id . ",this)'><img src='image/delete_16.png' title='Delete'></img></a></td>" ;
		// 	$list .= "</tr>" ;
		// }
		
		// unset($rows) ;
		// unset($cls) ;
		// return $list ;

		//======================================================

		$cls = new ModelClass($this->db) ;
		$clsBrand = new BrandClass($this->db) ;

		$filter = $this->db->fieldParam(ModelTable::C_ORG_ID) ;
		$params = array() ;
		$params[] = $this->db->valueParam(ModelTable::C_ORG_ID,$_SESSION[SE_ORGID]) ;
		$rows = $cls->getTable($filter,ModelTable::C_DESC,$params) ;
		$arrList = [];
		foreach ($rows as $i => $row) {
			$brand = ($row[ModelTable::C_BRAND_ID]==0)?'-':$clsBrand->getRecord($row[ModelTable::C_BRAND_ID])[BrandTable::C_DESC];

			$arrList[$i]["id"] = $row[ModelTable::C_ID];
			$arrList[$i]["code"] = $row[ModelTable::C_CODE];	
			$arrList[$i]["desc"] = $row[ModelTable::C_DESC];	
			$arrList[$i]["brand"] = $brand;	
			$arrList[$i]["actions"] = '<a onclick="javascript:editModel('.$row[ModelTable::C_ID].',this);" class="btn btn-sm btn-clean btn-icon btn-icon-md" title="Edit details">
									   	<i class="fa fa-edit"></i>
									   </a>
									   <a onclick="javascript:deleteModel('.$row[ModelTable::C_ID].',this);" class="btn btn-sm btn-clean btn-icon btn-icon-md" title="Delete">
									   	<i class="fa fa-trash"></i>
									   </a>';	
		}

		$this->sendJsonResponse(Status::Ok,"",$arrList,$this->type);
		
		unset($rows) ;
		unset($cls) ;
	}
	private function getRecord($params=null) {
		if (isset($params['id'])) {
			$id = $params['id'] ;
			$cls = new ModelClass($this->db) ;
			$row = $cls->getRecord($id) ;
			if (is_null($row)) {
				$this->sendJsonResponse(Status::Error,"Invalid Model id. Please try again.",$id,$this->type);
			} else {
				$datas = array() ;
				$datas['id'] = $id ;
				$datas['desc'] = $row[ModelTable::C_DESC];
				$datas['code'] = $row[ModelTable::C_CODE];
				$datas['ref'] = $row[ModelTable::C_REF];
				$datas['brand'] = $row[ModelTable::C_BRAND_ID];
				$this->sendJsonResponse(Status::Ok,"",$datas,$this->type) ;
			}
			unset($cls) ;
		} else {
			$this->sendJsonResponse(Status::Error,"Missing Model id. Please try again.","",$this->type);
		}
	}
	private function getView() {
        // Log::write("Model " . $this->getWebPageURL());
		ob_start() ;
		include (PATH_VIEWS . "activity/ModelView.php") ;
		echo Util::minifyHtml(ob_get_clean()) ;
	}
	private function getReport($params=null) {
		require_once(PATH_LIB . 'ListPdf.php');
	
		$cls = new ModelClass($this->db) ;
		$filter = $this->db->fieldParam(ModelTable::C_ORG_ID) ;
		$params = array() ;
		$params[] = $this->db->valueParam(ModelTable::C_ORG_ID,$_SESSION[SE_ORGID]) ;
		$rows = $cls->getTable($filter,ModelTable::C_ID,$params) ;
	
		$i = 'items';
		$nr = 'newrow';
		$datas = array() ;
		foreach ($rows as $row) {
			$items = array() ;
			$items[$i][] = $this->createPdfItem($row[ModelTable::C_ID],30) ;
			$items[$i][] = $this->createPdfItem($row[ModelTable::C_CODE],120) ;
			$items[$i][] = $this->createPdfItem($row[ModelTable::C_DESC],200) ;
			$items[$i][] = $this->createPdfItem($row[ModelTable::C_REF],200) ;
			$items[$i][] = $this->createPdfItem($row[ModelTable::C_BRAND_ID],200) ;
			$items[$nr] = "1";
			$datas[] = $items ;
		}
		$cols = array() ;
		$cols[] = $this->createPdfItem("ID",30,0,"C","B");
		$cols[] = $this->createPdfItem("Code",120,0,"C","B") ;
		$cols[] = $this->createPdfItem("Description",200,0,"C","B") ;
		$cols[] = $this->createPdfItem("Reference",200,0,"C","B") ;
		$cols[] = $this->createPdfItem("Brand",200,0,"C","B") ;
		$pdf = new ListPdf('P');
		$pdf->setCompanyName($_SESSION[SE_ORGNAME]) ;
		$pdf->setReportTitle("Model Listing") ;
		$pdf->setColumnsHeader($cols) ;
		$pdf->render($datas) ;
		$pdf->Output('model.pdf', 'I');
		unset($rows) ;
		unset($cls) ;
		unset($datas) ;
		unset($params) ;
		unset($items) ;
		unset($cols) ;
	}

	private function getBrand() {
		$vls = $this->getValueList(BrandTable::C_TABLE, BrandTable::C_ID, BrandTable::C_DESC,array('code'=>'0','desc'=>'--- Select a Brand ---')) ;
		return Util::createOptionValue($vls) ;
	}
}
?>